﻿Imports System.Text.RegularExpressions

#If False Then
Encoding.Default            'Ansi (CP1252 bei deutschem Windows)
Encoding.GetEncoding(1252)  'Ansi
Encoding.UTF8               'UTF8
Encoding.GetEncoding(65001) 'UTF8
Encoding.Unicode            'UTF16LE
Encoding.GetEncoding(437)   'OEM (DOS) 437
Encoding.ASCII              'Nur 7-Bit Zeichen (bis Zeichen 127)
#End If

Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Xml.Serialization

Namespace System.IO

   Public Module SystemIOX

      ''' <summary> kopiert von einem Stream in einen anderen </summary>
      ''' <remarks> 
      ''' Es gibt Streams ohne festgelegtes Ende (zB. NetworkStream).
      ''' In solchem Fall **muß** 'count' angegeben werden.
      ''' </remarks>
      <Extension()> _
      Public Sub WriteTo( _
                 readStream As Stream, _
                 writeStream As Stream, _
                Optional count As Long = -1, _
                Optional bufSize As Integer = 1024)
         Dim buf(bufSize - 1) As Byte
         If count < 0 AndAlso readStream.CanSeek Then
            count = readStream.Length - readStream.Position
         End If
         If count < 0 Then
            ' Durch 0-Byte-Lesevorgang terminierte Kopier-Schleife
            ' Ein NetworkStream würde ein Timeout-Problem verursachen
            Do
               Dim portion = readStream.Read(buf, 0, bufSize)
               If portion = 0 Then Return
               writeStream.Write(buf, 0, portion)
            Loop
         Else
            ' zähler-gesteuerte Kopier-Schleife
            Do
               If count < bufSize Then bufSize = CInt(count)
               Dim portion = readStream.Read(buf, 0, bufSize)
               If portion = 0 Then Throw New ArgumentException( _
                  "Die angegebene Anzahl Bytes konnte nicht aus dem Lese-Stream gelesen werden", _
                  "readStream + count")
               count -= portion
               writeStream.Write(buf, 0, portion)
            Loop Until count = 0
         End If
      End Sub

   End Module

End Namespace